<?php
//
// SourceForge: Breaking Down the Barriers to Open Source Development
// Copyright 1999-2000 (c) The SourceForge Crew
// http://sourceforge.net
//
// $Id: qrs2.php,v 1.8 2000/11/09 16:31:33 dbrogdon Exp $

require ('pre.php');    
require ($DOCUMENT_ROOT.'/project/admin/project_admin_utils.php');
require ('frs.class');

/*
	Quick file release system , Darrell Brogdon, SourceForge, Aug, 2000
*/

session_require(array('group'=>$group_id,'admin_flags'=>'A'));
project_admin_header(array('title'=>'Release New File Version','group'=>$group_id));

$frs = new FRS($group_id);

if( $submit) {
	if( $frs->isError() ) {
		$feedback .= $frs->getErrorMessage();
	}
	
	if( !$release_name ) {
		$feedback .= ' Must must define a release name. ';
 	} else {
		// See if this package belongs to this project
		$frs->frsVerifyPackage($package_id);
		if( $frs->isError() ) {
			$feedback .= $frs->getErrorMessage();
		}

		// Otherwise, create the release
		$res = $frs->frsAddRelease($release_name, $package_id, $release_notes, $release_changes, $file_type, $proc_type);
		if( $frs->isError() ) {
			$feedback .= $frs->getErrorMessage();
		} else {
			$release_id = db_insertid($res);
			$feedback .= '| Added Release ';
		}

		// Add a file to this release
		$group_unix_name=group_getunixname($group_id);
		$project_files_dir=$FTPFILES_DIR.$group_unix_name;

		if ($file_name) {
			$feedback .= '| Adding File ';

			// Check to see if the user uploaded a file instead of selecting an existing one.
			// If so then move it to the 'incoming' dir where we proceed as usual.
			if( $file_name == "qrs_newfile" ) {
				$file_name = $userfile_name;
				$new_userfile = explode("/tmp/", $HTTP_POST_FILES['userfile']['tmp_name']);

				if (is_file("/tmp/$new_userfile[1]") && file_exists("/tmp/$new_userfile[1]")) {
					exec("/usr/local/bin/tmpfilemove $new_userfile[1] $userfile_name",$exec_res);
					if ($exec_res[0]) {
						echo '<h2>' . $exec_res[0],$exec_res[1] . '</h2>';
					}
					for( $x=0; $x<count($exec_res); $x++ ) {
						print("$x: $exec_res[$x]<br>\n");
					}
				} else {
					$feedback .= " | Temp File Does Not Exist [USERFILE: $new_userfile[1], FILENAME: $file_name]";
				}
			}

			if( !util_is_valid_filename($file_name) ) {
				$feedback .= " Illegal FileName: $file_name ";
			} else {
				// Make sure they don't already have a file by this name
				$frs->frsVerifyFileExist($file_name, $release_id, $group_id);
				if( $frs->isError() ) {
					$feedback .= $frs->getErrorMessage();
				} else {
					// Move the file to the project's fileserver directory
					$frs->frsMoveFile($file_name, $group_unix_name, time(), $FTPINCOMING_DIR, $release_id);
					if( $frs->isError() ) {
						$feedback .= $frs->getErrorMessage(); 
					} else {
						// Add the file to the database
						$frs->frsAddFile(time(), $file_name, filesize($userfile), time(), $release_id, $package_id, $type_id, $processor_id);
						if( $frs->isError() ) {
							$feedback .= $frs->getErrorMessage(); 
						} else {
							$feedback .= " | File Added ";
						}
					}
				}
			}
		}
	}
} else {
?>

<form enctype="multipart/form-data" method="post" action="<?php echo $PHP_SELF; ?>">
<input type="hidden" name="MAX_FILE_SIZE" value="100000000">
<table border="0" cellpadding="2" cellspacing="2">
<tr>
	<td><b>Package ID:</b></td>
	<td>
		<?php
			$sql="SELECT * FROM frs_package WHERE group_id='$group_id'";
			$res=db_query($sql);
			$rows=db_numrows($res);
			if (!$res || $rows < 1) {
				echo '<H4>No File Types Available</H4>';
			} else {
				echo '<SELECT NAME="package_id">';
				for ($i=0; $i<$rows; $i++) {
					echo '<OPTION VALUE="' . db_result($res,$i,'package_id') . '">' . db_result($res,$i,'name') . '</OPTION>';
				}
				echo '</SELECT>';
			}
		?>
		&nbsp;&nbsp;&nbsp; Or, <a href="editpackages.php?group_id=<?php echo $group_id; ?>">create a new package</a>
	</td>
</tr>
<tr>
	<td><b>Release Name:</b></td>
	<td><input type="text" name="release_name" value="<?php echo $frs->frsResolveRelease($release_id); ?>"></td>
</tr>
<tr>
	<td><b>Release Date:</b></td>
	<td><input type="text" name="release_date" value="<?php echo date('Y-m-d'); ?>" size="10" maxlength="10"></td>
</tr>
<tr>
	<td><b>Status:</b></td>
	<td><?php echo frs_show_status_popup($name='status_id'); ?></td>
</tr>
<tr>
	<td><b>File Name:</b></td>
	<td>
		<?php
			$dirhandle = opendir($FTPINCOMING_DIR);

			echo '<SELECT NAME="file_name">\n';
			echo '	<OPTION VALUE="qrs_newfile">Select a file</OPTION>';
			//iterate and show the files in the upload directory
			while ($file = readdir($dirhandle)) {
				if (!ereg('^\.',$file[0])) {
					$atleastone = 1;
					print '<OPTION value="'.$file.'">'.$file.'</OPTION>';
				}
			}
			echo '</SELECT>';
		?>
		&nbsp;&nbsp;&nbsp; Or, upload a new file: &nbsp;&nbsp; <input name="userfile" type="file" size="30"> 
		<?php
			if (!$atleastone) {
		?>

		<h3>No available files</H3>
		<P>
		You can upload files using FTP to <B>download.sourceforge.net</B> 
		in the <B>/incoming</B> directory, then hit <B>Refresh View</B>

		<?php
			}
			
			$res1 = $frs->frsGetRelease($release_id); 
		?>
	</td>
</tr>
<tr>
	<td><b>File Type:</b></td>
	<td><?php echo frs_show_filetype_popup($name='type_id'); ?></td>
</tr>
<tr>
	<td><b>Processor Type:</b></td>
	<td><?php echo frs_show_processor_popup($name='processor_id'); ?></td>
</tr>
<tr>
	<td><b>Release Notes:</b></td>
	<td>
		<textarea name="release_notes" rows="7" cols="50"><?php echo db_result($res1,0,"notes"); ?></textarea>
	</td>
</tr>
<tr>
	<td><b>Change Log:</b></td>
	<td><textarea name="release_changes" rows="7" cols="50"><?php echo db_result($res1,0,"changes"); ?></textarea></td>
</tr>
<tr>
	<td colspan="2" align="center">
		<input type="hidden" name="group_id" value="<?php echo $group_id; ?>">
		<input type="submit" name="submit" value="Submit File Release">
	</td>
</tr>
</table>
</form>

<?php
}

project_admin_footer(array());
?>
